function readSettings()
{
  townIndex = System.Gadget.Settings.read("townIndex");
  townIndex=townIndex.substring(0,5);
  townName = System.Gadget.Settings.read("townName");
  countryName = System.Gadget.Settings.read("countryName");

  if (countryName=="") {zone="ua"} else {zone="ru";}

  if ((townIndex == "")||(townName == "")) {townIndex ="27612"; townName=""; countryName="";}
}

function checkUpdate()
{
  var url="http://news.gismeteo.ru/cgi-bin/gmnews.exe/export?mode=xml&count=3&r="+Math.random();

  if (reqcheck) reqcheck=null;
  try
  {
    reqcheck=new XMLHttpRequest();
    reqcheck.open("HEAD",url, true);
    reqcheck.onreadystatechange = processReqChange;
    timerCheck=setTimeout("reqcheck.abort();", 5000);
    reqcheck.send();
  }
  catch(err) {
    bGetUpdate=false;  
  }
}

function processReqChange()
{
  if (reqcheck.readyState == 4){
    clearTimeout(timerCheck);
    if (reqcheck.status == 200){
      if (lastNewsLength!=reqcheck.getResponseHeader("Content-Length")) 
      {
        lastNewsLength=reqcheck.getResponseHeader("Content-Length");
        bGetUpdate=true;
      }
      else bGetUpdate=false;
    }
    else bGetUpdate=false;  
  }
}

function loadFrcContent()
{
  clTimer(timerUpdateFrc);
  townname.innerHTML="     Gismeteo.RU";
  var url = "http://informer.gismeteo.ru/xml/"+townIndex+"_1.xml?r="+Math.random();
  if (reqfrc) reqfrc=null;
  try
  {
    reqfrc= new XMLHttpRequest();
    reqfrc.open("GET",url, true);
    reqfrc.onreadystatechange=processReqFrcContent;
    reqfrc.send();
  }
  catch(err) {   
  }  
}

function processReqFrcContent()
{
    if (reqfrc.readyState == 4)
    { 
       if (reqfrc.status == 200)
       { 
         parsingFrcXml(reqfrc.responseXML);
         clearContent();
    	 showContentDockedGadget();
         showContentUnDockedGadget();
	 clTimer(timerUpdateFrc);
    	 timerUpdateFrc=setInterval("loadFrcContent();", 60000*60*3); 
       }
       else
       {
         showErrorContentDockedGadget();
         lastNewsLength=null;
	 clTimer(timerUpdateFrc);
    	 timerUpdateFrc=setInterval("loadFrcContent();", 10000);
         loadNewsContent(); 
       }
    }
}

function loadNewsContent()
{
  var url = "http://news.gismeteo.ru/cgi-bin/gmnews.exe/export?mode=xml&count=3&r="+Math.random();
  if (reqnews) reqnews=null;
  try
  {
    reqnews=new XMLHttpRequest();
    reqnews.open("GET",url, true);
    reqnews.onreadystatechange=processReqNewsContent;
    reqnews.send();
  }
  catch(err) {   
  } 

}

function processReqNewsContent()
{
    if (reqnews.readyState == 4)
    { 
       if (reqnews.status == 200)
       { 
	  parsingNewsXml(reqnews.responseXML);
          showContentUnDockedGadget();	
       }
    }
}

function parsingFrcXml(xrequest)
{
  var forecast = xrequest.documentElement.getElementsByTagName('FORECAST'); 
  for(i=0; i<forecast.length; i++){
      param = new FrcParam;
      param.day=forecast[i].getAttribute("day");
      param.month=forecast[i].getAttribute("month");
      param.period = forecast[i].getAttribute("tod");
      for(j=0; j<forecast[i].childNodes.length; j++)
      {
        if(forecast[i].childNodes(j).nodeType==1)
	{
	  var name=forecast[i].childNodes(j).nodeName;
	  switch (name)
	  {
	    case 'PHENOMENA':
	    {
	      param.cloudiness=forecast[i].childNodes(j).getAttribute("cloudiness");
	      param.precipitation=forecast[i].childNodes(j).getAttribute("precipitation");
     
	    }
	    case 'PRESSURE':
	    {
	      param.pressure=eval(forecast[i].childNodes(j).getAttribute("min"))+eval(forecast[i].childNodes(j).getAttribute("max"));
	    }

	    case 'TEMPERATURE':
	    {
	      param.temper=eval(forecast[i].childNodes(j).getAttribute("min"))+eval(forecast[i].childNodes(j).getAttribute("max"));
	    } 
	  }
        }		
      }
      param=createWeatherParam(param);
      paramsArray[i]=param;
      delete param;
  }
  return true; 
}


function createWeatherParam(param) {
	
 if (param.day.length==1) param.day='0'+param.day;
 if (param.month.length==1) param.month='0'+param.month;
 if (param.weekday!=null) param.textdate=param.day+"/"+param.month+', '+weekdaysArray[param.weekday-1];	
 else param.textdate=param.dayday+"/"+param.month;
	
 if ((param.precipitation==4) || (param.precipitation==5))
 {
   if (param.cloudiness==2) { param.pic="2"; param.textcloudiness=imghintArray[4];}
   if (param.cloudiness==3) { param.pic="3"; param.textcloudiness=imghintArray[5];}
   param.prec="rain";
   param.textcloudiness=imghintArray[4];
		
 }

 if ((param.precipitation==6) || (param.precipitation==7))
 {
   if (param.cloudiness==2) { param.pic="2"; param.textcloudiness=imghintArray[6];}
   if (param.cloudiness==3) { param.pic="3"; param.textcloudiness=imghintArray[7];}
   param.prec="snow";
   param.textcloudiness=imghintArray[6];
 }

 if (param.precipitation==8) 
 {
    param.pic="2";
    param.prec="storm";
    param.textcloudiness=imghintArray[8];		
 }
 if (param.precipitation==10) 
 {
   if (param.cloudiness==0) param.pic="0";
   if (param.cloudiness==1) param.pic="1";
   if (param.cloudiness==2) param.pic="2";
   if (param.cloudiness==3) param.pic="3";
   param.prec="nprec";
   param.textcloudiness=imghintArray[+(param.cloudiness)];			
 }

 param.temper=param.temper / 2;
 if (param.temper>0) param.temper="+"+param.temper;
 param.temper=param.temper+"&deg;";
	
 param.pressure=Math.round(param.pressure / 2);	

 return param;			
	
}

function parsingNewsXml(xrequest)
{
   var newsitem = xrequest.documentElement.getElementsByTagName('item');
   for(i=0; i<newsitem.length; i++){
      news = new gNews;
      for(j=0; j<newsitem[i].childNodes.length; j++)
      {
        if(newsitem[i].childNodes(j).nodeType==1)
	{
           var name=newsitem[i].childNodes(j).nodeName;
           switch (name)
           {
	    case 'title':
	    {
	      news.title=newsitem[i].childNodes(j).text;
	    }
	    case 'link':
	    {
	      news.link=newsitem[i].childNodes(j).text;
	    }
	    case 'description':
	    {
	      news.text=newsitem[i].childNodes(j).text;
	    }
	    case 'pubDate':
	    {
	      news.date=newsitem[i].childNodes(j).text;
	    }

           }
        }
      }
      newsArray[i]=news;
      delete news;
   }
}